/* test2.c

   measure pulse width of input signal
   
*/

#include <stdio.h>
#include <ftdi.h>

#define RXBUFSZ	2048

int main(int argc, char **argv)
{
    int ret;
    struct ftdi_context ftdic;
    ftdi_init(&ftdic);
    unsigned char buf[RXBUFSZ];
    int i;
    FILE *outf;
    int ctr;
    int state;
    int npulses;
              
    /*
    if((ret = ftdi_usb_open(&ftdic, 0x0403, 0x6001)) < 0) {
        fprintf(stderr, "unable to open ftdi device: %d (%s)\n", ret, ftdi_get_error_string(&ftdic));
        return EXIT_FAILURE;
    }
    */
    
    if((ret = ftdi_usb_open_desc(&ftdic, 0x0403, 0x6001, NULL, "FTE1G5RU")) < 0) {
        fprintf(stderr, "unable to open ftdi device: %d (%s)\n", ret, ftdi_get_error_string(&ftdic));
        return EXIT_FAILURE;
    }
    
    ret = ftdi_enable_bitbang(&ftdic,0x04);
    if (ret<0)
    {
      fprintf(stderr,"unable to enable bitbang mode\n");
      return EXIT_FAILURE;
    }
    
    ret = ftdi_set_baudrate(&ftdic,4500);
    if (ret<0)
    {
      fprintf(stderr,"Unable to set required baudrate\n");
      return EXIT_FAILURE;
    }
    
    outf = fopen("pulses.txt","wt");
    if (outf == NULL)
    {
      fprintf(stderr,"unable to open output file");
      return EXIT_FAILURE;
    }    
    
    ctr = 0;
    state = 0;
    npulses=0;
    
    while (npulses<500)
    {
      ret = ftdi_read_data(&ftdic,buf,RXBUFSZ);
      if (ret<0)
      {
        fprintf(stderr,"error buffering block\n");
        return EXIT_FAILURE;
      }
      else
      {
        for (i=0; i<ret; i++)
        {
          // observer the samples, and check how many samples are between a change of the input signal
          if (buf[i] != state)
          {
            // store the pulsewidth:
            fprintf(outf,"%d\n",ctr);
            ctr = 0;
            state = buf[i];
            npulses++;
          }
          else
          {
            ctr++;
          }
        }
      }
      
    }

    ftdi_usb_close(&ftdic);
    ftdi_deinit(&ftdic);

    return EXIT_SUCCESS;
}

